/*Copyright (C) 2010-2012 Duncan Deveaux

This file is part of Hikou no mizu.

Hikou no mizu is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Hikou no mizu is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Hikou no mizu.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef DEF_PLAYER_WIDGET
#define DEF_PLAYER_WIDGET

#include "Graphics/Drawable/Text.hpp"
#include "Graphics/Drawable/Polygon.hpp"
#include "Player/Player.hpp"

#include <string>
#include <sstream>

class PlayerWidget : public Drawable
{
    public:
        PlayerWidget();
        void draw();
        
        void update();
        
        //Get and set methods
        void setPlayer(Player &player);
        const Player &getPlayer() const;
        
        void setFonts(Font &nameFont, Font &barsFont);
        const Font &getNameFont() const;
        const Font &getBarsFont() const;
        
        float getWidth() const;
        float getHeight() const;
    
    private:
        void init();
        
        Player *m_player;
        
        Text m_name, m_lifeText;
        Polygon m_lifeBar;
        
        float m_barsWidth, m_barsHeight;
};

#endif
